//BLISS Terminal System Shell
//Sophie Spaan 2022 (6-4-22) start date
//Terminal Ver. Indev 2.0
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>

#ifdef __WIN32
#define CLEAR_COMMAND "cls"
#define COMPILE_COMMAND "internalCompiler.bat"
#define MAKE_DIRECTORY "md "
#else
#define CLEAR_COMMAND "clear"
#define COMPILE_COMMAND "sudo bash internalCompiler.sh"
#define MAKE_DIRECTORY "mkdir "
#endif


int main(int argc, char **argv) {
    //Version data
    if (argc >= 2 && !strcmp(argv[1], "--v")) {
        printf("BLISS V2.0\n");
        return 0;
    }
    else if (argc >= 2 && !strcmp(argv[1], "--test")) {
        printf("Bliss but profile mode");
    }

    system(CLEAR_COMMAND);
    char *command = NULL;
    char delim[] = "=";
    char* tokenCommand[4] = {};
    char globalTemp[] = "";
    char dashes[] = "prof --";

    printf("Bliss Terminal Project\n");

    while(1) {
        printf("B:>");
        size_t length = 64;
        getline(&command, &length, stdin);
        char *ptr = strtok(command, delim);

        int loopCounter = 0;
        while(ptr != NULL) {
            loopCounter ++;
            tokenCommand[loopCounter] = ptr;
            ptr = strtok(NULL, delim);
        }

        if(!strcmp(tokenCommand[1], "exit\n")) {
            printf("Terminal Session Terminated. Have a nice day!\n");
            break;
        }
        else if(!strcmp(tokenCommand[1], "cls\n")) {
            system(CLEAR_COMMAND);
        }
        else if(!strcmp(tokenCommand[1], "help\n")) {
            system("help");
        }
        else if(!strcmp(tokenCommand[1], "edit\n")) {
            system("edit");
            system(CLEAR_COMMAND);
        }
        else if(!strcmp(tokenCommand[1], "rcall\n")) {
            system(COMPILE_COMMAND);
            printf("Done!\n\n");
        }
        else if(!strcmp(tokenCommand[1], "rcedit\n")) {
            system("gcc edit.c -o edit -lncurses");
            printf("Done!\n\n");
        }
        else if(!strcmp(tokenCommand[1], "info\n")) {
            system("info");
        }
        else if(!strcmp(tokenCommand[1], "exec")) {
            system(tokenCommand[2]);
        } 
        else if(!strcmp(tokenCommand[1], "echo")) {
            printf("%s", tokenCommand[2]);
        }
        else if(!strcmp(tokenCommand[1], "mdir")) {
            tokenCommand[2][strlen(tokenCommand[2]) - 1] = '\0';
            strcat(globalTemp, MAKE_DIRECTORY);
            strcat(globalTemp, tokenCommand[2]);
            system(globalTemp);
        }
        else if(!strcmp(tokenCommand[1], "blsc\n")) {
            system("blsc");
        }
        else if(!strcmp(tokenCommand[1], "prof")) {
            strcat(dashes, tokenCommand[2]);
            system(dashes);
        }
        else {
            printf("Previous input not recognised as internal command. Check spelling and try again.\n\n");
        }


    }
    
    free(command);
    return 0;   
}
