//Bliss Edit (BLEdit) Project
//Sophie Spaan 2022 
//Project Ver. Indev 2.0
#include <ncursesw\curses.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>

//Change commands for operating systems
#ifdef __WIN32
#define RM_COMMAND "del bliss.tmp"
#define CP_COMMAND "copy bledit.tmp"
#else
#define RM_COMMAND "rm bliss.tmp "
#define CP_COMMAND "cp bledit.tmp "
#endif


//Draw Text Box Borders
void textBox(int cursory, int cursorx) {
    int counter = 2;

    char borderLine[]  = "+==============+=========================================+==========+==========+\n";
    char titleBar[]    = "| BLEdit V 2.0 |                                         | exit()   | save()   |\n";
    char dataBarLine[] = ".                                                                              .\n";

    mvprintw(0, 0, "%s", titleBar);
    mvprintw(1, 0, "%s", borderLine);
    mvprintw(50, 0, "%s", dataBarLine);
    move(2, 0);
}

void tempFileHandling(char *string) {
    FILE *temp = fopen("bledit.tmp", "a");
    fseek(temp, 0, SEEK_END);
    fprintf(temp, string);
    fprintf(temp, "\n");
    fclose(temp);
}

void getTextInput(int cursory, int cursorx) { 
    char string[2048];
    char fileName[128]; 
    
    while (true) {
        getstr(string);
        if(!strcmp(string, "exit()")) {
            break;
        } else if (!strcmp(string, "save()")) {
            clear();
            mvprintw(0, 0, "%s", "File name and path: ");
            getstr(fileName);
            
            char command[512] = CP_COMMAND;
            strcat(command, fileName);
            system(command);
            system(RM_COMMAND);
        }
        else {
            tempFileHandling(string);
            erase();
            textBox(cursory, cursorx);
            move(2, 0);
        }
    }
}
//
//
//
//
//
int main(int argc, char **argv) {
    //Version data
    if (argc >= 2 && !strcmp(argv[1], "--v")) {
        printf("EDIT  V2.0\n");
        return 0;
    }

    int cursory, cursorx = 0;
    system(RM_COMMAND);

    initscr();
    cbreak();
    resize_term(50, 80);
    wrefresh(stdscr);

    textBox(cursory, cursorx);
    getTextInput(cursory, cursorx);
    
    endwin();
    return 0;
}
